## hardening-wrapper 1.11

=== tests/Makefile ===
#!/usr/bin/make -f

BUILD_TREE=../build-tree

WRAPPED_CC=$(BUILD_TREE)/hardened-cc
WRAPPED_CXX=$(BUILD_TREE)/hardened-c++
WRAPPED_LD=$(BUILD_TREE)/hardened-ld

# It seems that GCC_EXEC_PREFIX does not behave the same across all
# architectures, so we need to pass the -B flag instead.
CC=$(WRAPPED_CC) -B $(BUILD_TREE)/

WRAPPERS=$(WRAPPED_CC) $(WRAPPED_LD) $(WRAPPED_CXX)


SYMLINKED_LD=$(BUILD_TREE)/ld

HELLO=hello.c

TEST_REQS=$(HELLO) $(WRAPPERS) $(SYMLINKED_LD)

export HARDENING_USE_USR_BIN=1
export DEB_BUILD_HARDENING=1
export DEB_BUILD_HARDENING_DEBUG=1

TESTS=\
	syntax.stamp \
	$(BUILD_TREE)/test-stock \
	$(BUILD_TREE)/test-compiled \
	$(SYMLINKED_LD) \
	$(BUILD_TREE)/test-linked \
	$(BUILD_TREE)/test-fPIC-direct \
	$(BUILD_TREE)/test-fPIC

check: $(TESTS)

clean:
	rm -f $(TESTS)

syntax.stamp: $(WRAPPERS)
	# Test basic perl syntax
	for script in $(WRAPPERS); do perl -c $$script; done
	touch $@

##########
# Compilation and linking results tests

$(BUILD_TREE)/test-stock: $(HELLO) $(WRAPPERS)
	# Compiler and linker options disabled.
	DEB_BUILD_HARDENING=0 $(CC) -o $@ $<
	readelf -l $@
	$@

$(BUILD_TREE)/test-compiled: $(HELLO) $(WRAPPERS)
	# Compiler options enabled. (linker is system-default)
	$(CC) -o $@ $<
	readelf -l $@
	# Run twice to show off PIE, if available in kernel
	$@
	$@

$(SYMLINKED_LD): $(WRAPPED_LD)
	# Enable symlink for ld to trick gcc into doing wrapped linking
	(cd $(BUILD_TREE) && ln -s hardened-ld ld)

$(BUILD_TREE)/test-linked: $(TEST_REQS)
	# Compiler and linker options enabled.
	$(CC) -o $@ $<
	readelf -l $@
	# Run twice to show off PIE, if available in kernel
	$@
	$@


##########
# Compiler arg calling style tests

# cmake likes to pass -fPIC to everything, which broke pre-1.10 wrappers
$(BUILD_TREE)/test-fPIC-direct: $(TEST_REQS)
	# Build directly with -fPIC already defined
	$(CC) -fPIC -o $@ $<
	$@

$(BUILD_TREE)/test-fPIC.o: $(TEST_REQS)
	# Build .o with -fPIC already defined
	$(CC) -fPIC -o $@ -c $<

$(BUILD_TREE)/test-fPIC: $(BUILD_TREE)/test-fPIC.o $(TEST_REQS)
	# Link .o with -fPIC already defined
	$(CC) -fPIC -o $@ $<
	$@

=== debian/changelog ===
hardening-wrapper (1.11) unstable; urgency=low

  * hardened-ld: disable PIE logic -- gcc should be the only part of the
    toolchain requesting PIE.
  * tests/Makefile: use -B instead of GCC_EXEC_PREFIX, which does not
    do the right thing on all architectures.

 -- Kees Cook <kees@outflux.net>  Mon, 14 Apr 2008 16:06:00 -0700

hardening-wrapper (1.10) unstable; urgency=low

  * hardened-cc, hardened-ld: re-arranged logic for "-pie".  Old logic
    was resulting in failed compiles under cmake.
  * tests/Makefile: moved debian/rules tests into separate directory,
    added -fPIC test cases, based on issues uncovered by cmake.
  * debian/rules: disabled stack protector on mips, hppa -- not supported.

 -- Kees Cook <kees@outflux.net>  Mon, 14 Apr 2008 11:15:35 -0700

hardening-wrapper (1.9) unstable; urgency=low

  * debian/rules:
    - disable stack protector on arm, armel.
    - disable PIE on arm, armel (thanks to Riku Voipio, Closes: 475764).
    - show readelf output on test builds.
    - fully link by tricking gcc into running the ld test wrapper.
  * hello.c: re-arranged to exercise stack protector, report PIE.
  * hardened-ld: add env var way to force use of /usr/bin/ld during tests.

 -- Kees Cook <kees@outflux.net>  Sun, 13 Apr 2008 18:01:38 -0700

hardening-wrapper (1.8) unstable; urgency=low

  * debian/rules: disable stack protector on ia64 and alpha.

 -- Kees Cook <kees@outflux.net>  Sun, 23 Mar 2008 22:03:58 -0700

hardening-wrapper (1.7) unstable; urgency=low

  * debian/rules: corrected binary-arch target (Closes: 472324).

 -- Kees Cook <kees@outflux.net>  Sun, 23 Mar 2008 08:13:47 -0700

hardening-wrapper (1.6) unstable; urgency=low

  * debian/rules: build hardened-c++ from hardened-cc.
  * debian/{rules,control}, hardened-cc: disable PIE by default on m68k,
    hppa (Closes: #465827).
  * hello.c: added test program to catch architecture-specific failures.

 -- Kees Cook <kees@outflux.net>  Fri, 21 Mar 2008 11:20:53 -0700

hardening-wrapper (1.5) unstable; urgency=low

  * Fix typo in hardened-c++ self-check regex (Closes: #462682).

 -- Kees Cook <kees@outflux.net>  Sun, 27 Jan 2008 12:14:59 -0800

hardening-wrapper (1.4) unstable; urgency=low

  * hardened-ld: fix relro argument passing (ld silently takes any -z arg).

 -- Kees Cook <kees@outflux.net>  Wed, 23 Jan 2008 09:59:06 -0800

hardening-wrapper (1.3) unstable; urgency=low

  * hardened-{cc,c++}: fix -Wformat-security typo.
  * debian/postinst: only clean up old diversions on a versioned upgrade.
  * debian/postrm: do not require known arguments.

 -- Kees Cook <kees@outflux.net>  Wed, 23 Jan 2008 02:56:57 -0800

hardening-wrapper (1.2) unstable; urgency=low

  * Move away from generic "builder" prefix to "hardened".
  * Provide links for gcc 4.1, 4.2, and 4.3 instead of top-level links.
  * Provide manpage link for package name.
  * Clean up previous diversions.
  * Move to "all" arch since arch-dep symlinks are no longer used.

 -- Kees Cook <kees@outflux.net>  Tue, 22 Jan 2008 16:48:49 -0800

hardening-wrapper (1.1) unstable; urgency=low

  * Initial release.

 -- Kees Cook <kees@outflux.net>  Tue, 08 Jan 2008 16:00:58 -0800

=== debian/control ===
Source: hardening-wrapper
Section: devel
Priority: extra
Build-Depends: debhelper (>= 5.0.0)
Maintainer: Package Hardening <hardening-discuss@lists.alioth.debian.org>
Uploaders: Kees Cook <kees@outflux.net>, Moritz Muehlenhoff <jmm@debian.org>
Standards-Version: 3.7.3.0
Homepage: http://wiki.debian.org/Hardening
Vcs-Svn: svn://svn.debian.org/hardening/hardening-wrapper
Vcs-Browser: http://svn.debian.org/wsvn/hardening/hardening-wrapper/

Package: hardening-wrapper
Architecture: any
Depends: gcc | g++, ${perl:Depends}
Description: experimental compiler wrapper to enable security hardening flags
 Replaces gcc, g++, and ld with wrapper scripts that set security hardening
 compilation flags, as an alternative to changing gcc specs.  This is an
 experimental package intended for build testing.

=== debian/rules ===
#!/usr/bin/make -f
# Sample debian/rules that uses debhelper. GNU copyright 1997 by Joey Hess.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

DEB_HOST_ARCH_OS := $(shell dpkg-architecture -qDEB_HOST_ARCH_OS 2>/dev/null)
DEB_HOST_ARCH_CPU := $(shell dpkg-architecture -qDEB_HOST_ARCH_CPU 2>/dev/null)

# Calculate arch-specific defaults
DEFAULT_PIE=0
ifneq (,$(findstring :$(DEB_HOST_ARCH_OS):,:linux:knetbsd:))
  # PIE enabled only on linux/knetbsd
  ifeq (,$(findstring :$(DEB_HOST_ARCH_CPU):,:hppa:m68k:arm:))
    # disabled on hppa, m68k (where it doesn't work).
    # disabled for arm since there is no randomization support in ARM kernels
    DEFAULT_PIE=1
  endif
endif
DEFAULT_STACKPROT=1
ifneq (,$(findstring :$(DEB_HOST_ARCH_CPU):,:ia64:alpha:mips:mipsel:hppa:arm:))
  # Stack protector disabled on ia64, alpha, mips, mipsel, hppa.
  #   "warning: -fstack-protector not supported for this target"
  # Stack protector disabled on arm, armel.
  #   compiler supports it incorrectly (leads to SEGV)
  DEFAULT_STACKPROT=0
endif

build: build-stamp test
build-stamp:
	# Building
	dh_testdir

	mkdir -p build-tree
	install hardened-cc hardened-ld build-tree

	# Set defaults, based on OS and CPU
	perl -pi -e 's/ #OS#/ '"$(DEB_HOST_ARCH_OS)"'/; s/ #CPU#/ '"$(DEB_HOST_ARCH_CPU)"'/;' build-tree/hardened-cc build-tree/hardened-ld
	perl -pi -e "s/default{'DEB_BUILD_HARDENING_PIE'}=1;/default{'DEB_BUILD_HARDENING_PIE'}=$(DEFAULT_PIE);/;" build-tree/hardened-cc build-tree/hardened-ld
	perl -pi -e "s/default{'DEB_BUILD_HARDENING_STACKPROTECTOR'}=1;/default{'DEB_BUILD_HARDENING_STACKPROTECTOR'}=$(DEFAULT_STACKPROT);/;" build-tree/hardened-cc build-tree/hardened-ld

	# Duplicate cc wrapper to c++
	cp build-tree/hardened-cc build-tree/hardened-c++
	perl -pi -e 's/hardened-cc/hardened-c++/g; s|/usr/bin/cc|/usr/bin/c++|g;' build-tree/hardened-c++

	# Set up man pages
	ln -sf hardened-cc.1 hardening-wrapper.1
	cp hardened-cc.1 hardened-c++.1
	perl -pi -e 's/hardened-cc/hardened-c++/g; s/gcc/g++/g;' hardened-c++.1

	# Done building
	touch build-stamp

clean:
	dh_testdir
	dh_testroot

	rm -f build-stamp test-stamp
	rm -rf build-tree
	rm -f hardened-c++.1 hardening-wrapper.1
	dh_clean

test: build-stamp test-stamp
test-stamp:
	(cd tests; make check)
	# Done testing
	touch test-stamp

install: build
	dh_testdir
	dh_testroot
	dh_clean -k
	dh_installdirs usr/bin
	dh_installdirs -A usr/share/lintian/overrides
	install -m644 debian/lintian.overrides debian/hardening-wrapper/usr/share/lintian/overrides/hardening-wrapper
	install build-tree/hardened-cc build-tree/hardened-c++ build-tree/hardened-ld debian/hardening-wrapper/usr/bin
	# Build links
	for ver in 4.1 4.2 4.3; do dh_link \
		usr/bin/hardened-cc usr/bin/gcc-$$ver \
		usr/bin/hardened-c++ usr/bin/g++-$$ver \
		;\
	done
	dh_link usr/bin/hardened-ld usr/bin/ld


# Build architecture-dependent files here.
binary-arch: build install
#	dh_testversion
	dh_perl
	dh_testdir
	dh_testroot
	dh_installdocs AUTHORS TODO
	dh_installexamples
	dh_installmenu
#	dh_installinit
	dh_installcron
	dh_installman
#	dh_undocumented
	dh_installchangelogs
	dh_strip
	dh_compress
	dh_fixperms
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
#	dh_makeshlibs
	dh_md5sums
	dh_builddeb

# Build architecture-independent files here.
binary-indep: binary-arch
	# Nothing to do here

source diff:                                                                  
	@echo >&2 'source and diff are obsolete - use dpkg-source -b'; false

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary test

## hardening-wrapper 1.12

=== debian/changelog ===
hardening-wrapper (1.12) unstable; urgency=low

  * hardened-cc: add -nostdlib test missing from older gcc (gcc-4.0, gcc-4.1).
  * hardened-{cc,ld}: load system defaults from /etc/hardening-wrapper.conf
  * hardened-{cc,ld}.1: updated man pages to mention system-wide config.
  * hardened-{cc,ld}: handle relative symlinks correctly to address issues
    pointed out by Sedat Dilek.

 -- Kees Cook <kees@outflux.net>  Mon, 28 Apr 2008 15:51:57 -0700

=== debian/control ===
--- 
+++ 
@@ -3,14 +3,14 @@
 Priority: extra
 Build-Depends: debhelper (>= 5.0.0)
 Maintainer: Package Hardening <hardening-discuss@lists.alioth.debian.org>
-Uploaders: Kees Cook <kees@outflux.net>, Moritz Muehlenhoff <jmm@debian.org>
+Uploaders: tamanegimoyashi <tanimotoi@gmail.com> 
 Standards-Version: 3.7.3.0
 Homepage: http://wiki.debian.org/Hardening
 Vcs-Svn: svn://svn.debian.org/hardening/hardening-wrapper
 Vcs-Browser: http://svn.debian.org/wsvn/hardening/hardening-wrapper/
 
 Package: hardening-wrapper
-Architecture: any
+Architecture: armel
 Depends: gcc | g++, ${perl:Depends}
 Description: experimental compiler wrapper to enable security hardening flags
  Replaces gcc, g++, and ld with wrapper scripts that set security hardening

## hardening-wrapper 1.13

=== debian/changelog ===
hardening-wrapper (1.13) unstable; urgency=low

  * hardened-cc: add ...DEBUG_SYMLINKS to visualize symlink resolution.
  * hardened-cc: detect uninstalled targets and abort (Closes: #506066).
  * debian/{rules,postinst,postrm}: add links for gcc-4.4.
  * debian/control: moved to standards version 3.8.0, no changes needed.

 -- Kees Cook <kees@outflux.net>  Thu, 20 Nov 2008 23:25:52 -0800

=== debian/control ===
--- 
+++ 
@@ -3,14 +3,14 @@
 Priority: extra
 Build-Depends: debhelper (>= 5.0.0)
 Maintainer: Package Hardening <hardening-discuss@lists.alioth.debian.org>
-Uploaders: tamanegimoyashi <tanimotoi@gmail.com> 
-Standards-Version: 3.7.3.0
+Uploaders: Kees Cook <kees@outflux.net>, Moritz Muehlenhoff <jmm@debian.org>
+Standards-Version: 3.8.0
 Homepage: http://wiki.debian.org/Hardening
 Vcs-Svn: svn://svn.debian.org/hardening/hardening-wrapper
 Vcs-Browser: http://svn.debian.org/wsvn/hardening/hardening-wrapper/
 
 Package: hardening-wrapper
-Architecture: armel
+Architecture: any
 Depends: gcc | g++, ${perl:Depends}
 Description: experimental compiler wrapper to enable security hardening flags
  Replaces gcc, g++, and ld with wrapper scripts that set security hardening

=== debian/rules ===
--- 
+++ 
@@ -75,7 +75,7 @@
 	install -m644 debian/lintian.overrides debian/hardening-wrapper/usr/share/lintian/overrides/hardening-wrapper
 	install build-tree/hardened-cc build-tree/hardened-c++ build-tree/hardened-ld debian/hardening-wrapper/usr/bin
 	# Build links
-	for ver in 4.1 4.2 4.3; do dh_link \
+	for ver in 4.1 4.2 4.3 4.4; do dh_link \
 		usr/bin/hardened-cc usr/bin/gcc-$$ver \
 		usr/bin/hardened-c++ usr/bin/g++-$$ver \
 		;\

## hardening-wrapper 1.15

=== tests/Makefile ===
--- 
+++ 
@@ -1,4 +1,6 @@
 #!/usr/bin/make -f
+
+DEB_HOST_ARCH_CPU := $(shell dpkg-architecture -qDEB_HOST_ARCH_CPU 2>/dev/null)
 
 BUILD_TREE=../build-tree
 
@@ -48,13 +50,13 @@
 $(BUILD_TREE)/test-stock: $(HELLO) $(WRAPPERS)
 	# Compiler and linker options disabled.
 	DEB_BUILD_HARDENING=0 $(CC) -o $@ $<
-	readelf -l $@
+	readelf -ld $@
 	$@
 
 $(BUILD_TREE)/test-compiled: $(HELLO) $(WRAPPERS)
 	# Compiler options enabled. (linker is system-default)
 	$(CC) -o $@ $<
-	readelf -l $@
+	readelf -ld $@
 	# Run twice to show off PIE, if available in kernel
 	$@
 	$@
@@ -66,10 +68,16 @@
 $(BUILD_TREE)/test-linked: $(TEST_REQS)
 	# Compiler and linker options enabled.
 	$(CC) -o $@ $<
-	readelf -l $@
+	readelf -ld $@
 	# Run twice to show off PIE, if available in kernel
 	$@
 	$@
+ifeq (,$(findstring :$(DEB_HOST_ARCH_CPU):,:ia64:))
+	# Test for RELRO
+	readelf -l $@ | grep GNU_RELRO
+endif
+	# Test for BIND_NOW
+	readelf -d $@ | grep BIND_NOW
 
 
 ##########

=== debian/changelog ===
hardening-wrapper (1.15) unstable; urgency=low

  * tests/Makefile: exclude tests based on architecture (ia64 w/o relro).
  * debian/rules: disable PIE on mips/mipsel until bug 532821 is solved
    (Closes: #548250).

 -- Kees Cook <kees@debian.org>  Thu, 24 Sep 2009 15:34:51 -0700

hardening-wrapper (1.14) unstable; urgency=low

  * hardened-ld: add ...BINDNOW for -Wl,-z,now ELF markings.
  * debian/control: moved to standards version 3.8.2, no changes needed.
  * tests/Makefile: add tests for RELRO and BIND_NOW.
  * hardening-{cc,ld}.1: document BINDNOW and RELRO, add on to See Also.

 -- Kees Cook <kees@debian.org>  Wed, 22 Jul 2009 19:52:00 -0700

=== debian/control ===
--- 
+++ 
@@ -3,8 +3,8 @@
 Priority: extra
 Build-Depends: debhelper (>= 5.0.0)
 Maintainer: Package Hardening <hardening-discuss@lists.alioth.debian.org>
-Uploaders: Kees Cook <kees@outflux.net>, Moritz Muehlenhoff <jmm@debian.org>
-Standards-Version: 3.8.0
+Uploaders: Kees Cook <kees@debian.org>, Moritz Muehlenhoff <jmm@debian.org>
+Standards-Version: 3.8.2
 Homepage: http://wiki.debian.org/Hardening
 Vcs-Svn: svn://svn.debian.org/hardening/hardening-wrapper
 Vcs-Browser: http://svn.debian.org/wsvn/hardening/hardening-wrapper/

=== debian/rules ===
--- 
+++ 
@@ -11,8 +11,9 @@
 DEFAULT_PIE=0
 ifneq (,$(findstring :$(DEB_HOST_ARCH_OS):,:linux:knetbsd:))
   # PIE enabled only on linux/knetbsd
-  ifeq (,$(findstring :$(DEB_HOST_ARCH_CPU):,:hppa:m68k:arm:))
+  ifeq (,$(findstring :$(DEB_HOST_ARCH_CPU):,:hppa:m68k:arm:mips:mipsel:))
     # disabled on hppa, m68k (where it doesn't work).
+    # disabled on mips/mipsel due to bug 532821 in toolchain
     # disabled for arm since there is no randomization support in ARM kernels
     DEFAULT_PIE=1
   endif
@@ -111,7 +112,7 @@
 binary-indep: binary-arch
 	# Nothing to do here
 
-source diff:                                                                  
+source diff:
 	@echo >&2 'source and diff are obsolete - use dpkg-source -b'; false
 
 binary: binary-indep binary-arch

## hardening-wrapper 1.25

=== debian/changelog ===
hardening-wrapper (1.25) unstable; urgency=low

  * debian/control:
    - bump standards version: no changes needed.
    - should not be considered "experimental".
  * hardening-check: use readelf's "-s" instead of "-r" to avoid issues
    with archs that lack sane relocations.
  * tests/Makefile.common:
    - adjust tests to include -s output.
    - weaken nm symbol matching.

 -- Kees Cook <kees@debian.org>  Mon, 01 Mar 2010 14:54:34 -0800

hardening-wrapper (1.24) unstable; urgency=low

  * hardening-check: handle alternate names for relocation jump slots
    (Closes: 568622)
  * tests/Makefile.common: show relocations as well for future debugging.

 -- Kees Cook <kees@debian.org>  Tue, 09 Feb 2010 15:44:19 -0800

hardening-wrapper (1.23) unstable; urgency=low

  * hardening.make: correctly document how to disable PIE on a per-target
    basis (Closes: 567707).
  * tests/Makefile.{common,includes}: add HARDENING_DISABLE_* flags tests.

 -- Kees Cook <kees@debian.org>  Sat, 30 Jan 2010 13:32:14 -0800

hardening-wrapper (1.22) unstable; urgency=low

  * debian/hardening-wrapper.postrm: fix typo in diversion name
    (Closes: 564840).

 -- Kees Cook <kees@debian.org>  Tue, 12 Jan 2010 06:18:04 -0800

hardening-wrapper (1.21) unstable; urgency=low

  * debian/control: add ${misc:Depends} to control file entries to
    keep lintian happy.
  * hardening-check: add -q option to only report failures.
  * really handle gcc 4.5 diversion (Closes: 564596).
  * handle ld diversion when binutils-gold installed (Closes: 535037).

 -- Kees Cook <kees@debian.org>  Sun, 10 Jan 2010 12:35:38 -0800

hardening-wrapper (1.20) unstable; urgency=low

  * hardening.make:
    - switch to "filter" for easier to read logic.
    - allow PIE for arm/armel, since it's only the kernel that lacks ASLR.
  * tests/Makefile: perform test builds with -fstack-protector and -fPIE -pie
    on all architectures just to have a record of the success/failure
    in the build logs, even if we are manually selecting the defaults.

 -- Kees Cook <kees@debian.org>  Fri, 25 Dec 2009 16:34:24 -0800

hardening-wrapper (1.19) unstable; urgency=low

  * debian/rules: fix up arch/arch-indep rules to avoid rebuilding
    arch-indep bits repeatedly.
  * hardening-check, debian/{rules,hardening-includes.manpages},
    tests/Makefile.common: add helper utility to allow users of
    hardening-includes to evaluate the state of a given binary's
    resulting hardening features.
  * debian/rules: add gcc-4.5 to the diversion list.

 -- Kees Cook <kees@debian.org>  Thu, 24 Dec 2009 00:02:02 -0800

hardening-wrapper (1.18) unstable; urgency=low

  * debian/{control,rules}: add "hardening-includes" for use in other
    Debian rules files.
  * debian/rules, hardening.make: relocate/enhance architecture logic
    to common makefile include file.
  * tests/*: update to test both wrapper and include style.

 -- Kees Cook <kees@debian.org>  Sat, 19 Dec 2009 18:00:22 -0800

hardening-wrapper (1.17) unstable; urgency=low

  * Add Conflicts on binutils-gold, which also uses diversions against
    gcc and friends (Closes: 535037, LP: #442636).

 -- Kees Cook <kees@debian.org>  Wed, 25 Nov 2009 11:40:43 -0800

hardening-wrapper (1.16) unstable; urgency=low

  * tests/Makefile: exclude relro test on hppa.

 -- Kees Cook <kees@debian.org>  Thu, 29 Oct 2009 21:21:55 -0700

## hardening-wrapper 1.25maemo1

=== debian/changelog ===
hardening-wrapper (1.25maemo1) fremantle; urgency=low

  * Initial release for fremantle.

 -- Mohammad Abu-Garbeyyeh <mohammad7410@gmail.com>  Mon, 28 Jun 2010 14:46:35 +0300

=== debian/control ===
Source: hardening-wrapper
Section: devel
Priority: extra
Build-Depends: debhelper (>= 5.0.0)
Maintainer: Mohammad Abu-Garbeyyeh <mohammad7410@gmail.com>
Uploaders: Kees Cook <kees@debian.org>, Moritz Muehlenhoff <jmm@debian.org>, Package Hardening <hardening-discuss@lists.alioth.debian.org>
Standards-Version: 3.8.4
Homepage: http://wiki.debian.org/Hardening
Vcs-Svn: svn://svn.debian.org/hardening/hardening-wrapper
Vcs-Browser: http://svn.debian.org/wsvn/hardening/hardening-wrapper/

Package: hardening-wrapper
Architecture: any
Depends: gcc | g++, ${perl:Depends}, ${misc:Depends}
Description: Compiler wrapper to enable security hardening flags
 Replaces gcc, g++, and ld with wrapper scripts that set security hardening
 compilation flags, as an alternative to changing gcc specs.  Enabled when
 DEB_BUILD_HARDENING=1 is set.

Package: hardening-includes
Architecture: all
Depends: ${misc:Depends}
Description: Makefile for enabling compiler flags for security hardening
 Makefile to be included in Debian rules files.  CFLAGS and LDFLAGS
 can be extended to include the respective HARDENING_* variables which
 contain architecture-validated security hardening compiler options.

=== debian/rules ===
#!/usr/bin/make -f
# Sample debian/rules that uses debhelper. GNU copyright 1997 by Joey Hess.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

DEB_HOST_ARCH_OS := $(shell dpkg-architecture -qDEB_HOST_ARCH_OS 2>/dev/null)
DEB_HOST_ARCH_CPU := $(shell dpkg-architecture -qDEB_HOST_ARCH_CPU 2>/dev/null)

include hardening.make
DEFAULT_PIE:=$(DEB_BUILD_HARDENING_PIE)
DEFAULT_STACKPROT:=$(DEB_BUILD_HARDENING_STACKPROTECTOR)

build: build-stamp test
build-stamp:
	# Building
	dh_testdir

	mkdir -p build-tree
	install hardened-cc hardened-ld build-tree

	# Set defaults, based on OS and CPU
	perl -pi -e 's/ #OS#/ '"$(DEB_HOST_ARCH_OS)"'/; s/ #CPU#/ '"$(DEB_HOST_ARCH_CPU)"'/;' build-tree/hardened-cc build-tree/hardened-ld
	perl -pi -e "s/default{'DEB_BUILD_HARDENING_PIE'}=1;/default{'DEB_BUILD_HARDENING_PIE'}=$(DEFAULT_PIE);/;" build-tree/hardened-cc build-tree/hardened-ld
	perl -pi -e "s/default{'DEB_BUILD_HARDENING_STACKPROTECTOR'}=1;/default{'DEB_BUILD_HARDENING_STACKPROTECTOR'}=$(DEFAULT_STACKPROT);/;" build-tree/hardened-cc build-tree/hardened-ld

	# Duplicate cc wrapper to c++
	cp build-tree/hardened-cc build-tree/hardened-c++
	perl -pi -e 's/hardened-cc/hardened-c++/g; s|/usr/bin/cc|/usr/bin/c++|g;' build-tree/hardened-c++

	# Set up man pages
	ln -sf hardened-cc.1 hardening-wrapper.1
	cp hardened-cc.1 hardened-c++.1
	perl -pi -e 's/hardened-cc/hardened-c++/g; s/gcc/g++/g;' hardened-c++.1
	pod2man hardening-check > hardening-check.1

	# Done building
	touch build-stamp

clean:
	dh_testdir
	dh_testroot

	rm -f build-stamp test-stamp
	rm -rf build-tree
	rm -f hardened-c++.1 hardening-wrapper.1 hardening-check.1
	dh_clean

test: build-stamp test-stamp
test-stamp:
	(cd tests; make check)
	# Done testing
	touch test-stamp

install: build
	dh_testdir
	dh_testroot
	dh_clean -k
	dh_installdirs usr/bin
	dh_installdirs -phardening-wrapper -A usr/share/lintian/overrides
	install -m644 debian/lintian.overrides debian/hardening-wrapper/usr/share/lintian/overrides/hardening-wrapper
	install build-tree/hardened-cc build-tree/hardened-c++ build-tree/hardened-ld debian/hardening-wrapper/usr/bin
	# programatically build links (change debian/h-w.{preinst,postrm} too)
	for ver in 4.1 4.2 4.3 4.4 4.5; do dh_link -phardening-wrapper \
		usr/bin/hardened-cc usr/bin/gcc-$$ver \
		usr/bin/hardened-c++ usr/bin/g++-$$ver \
		;\
	done
	dh_link -phardening-wrapper usr/bin/hardened-ld usr/bin/ld.bfd
	dh_link -phardening-wrapper usr/bin/hardened-ld usr/bin/ld.gold
	install -m644 -D hardening.make debian/hardening-includes/usr/share/hardening-includes/hardening.make
	install -m755 -D hardening-check debian/hardening-includes/usr/bin/hardening-check


# Build architecture-dependent files here.
binary-arch: build install
#	dh_testversion -a
	dh_perl -a
	dh_testdir -a
	dh_testroot -a
	dh_installdocs -a AUTHORS TODO
	dh_installexamples -a
	dh_installmenu -a
#	dh_installinit -a
	dh_installcron -a
	dh_installman -a
#	dh_undocumented -a
	dh_installchangelogs -a
	dh_strip -a
	dh_compress -a
	dh_fixperms -a
	dh_installdeb -a
	dh_shlibdeps -a
	dh_gencontrol -a
#	dh_makeshlibs -a
	dh_md5sums -a
	dh_builddeb -a

# Build architecture-independent files here.
binary-indep: build install
	dh_testdir -i
	dh_testroot -i
	dh_installchangelogs -i
	dh_installdocs -i
	dh_installexamples -i
#	dh_installmenu -i
#	dh_installdebconf -i
#	dh_installlogrotate -i
#	dh_installemacsen -i
#	dh_installcatalogs -i
#	dh_installpam -i
#	dh_installmime -i
#	dh_installinit -i
#	dh_installcron -i
#	dh_installinfo -i
#	dh_installwm -i
#	dh_installudev -i
#	dh_lintian -i
#	dh_bugfiles -i
#	dh_undocumented -i
	dh_installman -i
	dh_link -i
	dh_compress -i
	dh_fixperms -i
#	dh_perl -i
	dh_installdeb -i
	dh_gencontrol -i
	dh_md5sums -i
	dh_builddeb -i

source diff:
	@echo >&2 'source and diff are obsolete - use dpkg-source -b'; false

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary test

## hardening-wrapper 1.28

=== debian/changelog ===
hardening-wrapper (1.28) unstable; urgency=low

  * hardening.make: enable PIE on hurd (Closes: 586215), thanks to
    Samuel Thibault.

 -- Kees Cook <kees@debian.org>  Sun, 20 Jun 2010 12:36:32 -0700

hardening-wrapper (1.27) unstable; urgency=low

  * hardening.make:
    - disable RELRO on avr32.
    - clarify use of CXXFLAGS.
  * hardening-check: fix regex to correctly call sed (Closes: 578488).

 -- Kees Cook <kees@debian.org>  Fri, 23 Apr 2010 16:16:25 -0700

hardening-wrapper (1.26) unstable; urgency=low

  * hardening.make: disable PIE on avr32 (Closes: 574716).

 -- Kees Cook <kees@debian.org>  Sun, 21 Mar 2010 09:45:52 -0700

## hardening-wrapper 1.29~bpo50+1

=== debian/changelog ===
hardening-wrapper (1.29~bpo50+1) lenny-backports; urgency=low

  * Non-maintaner upload for backports.org
  * Backport for Lenny Archive. 

 -- Ulises Vitulli <dererk@debian.org>  Mon, 12 Jul 2010 11:38:11 -0300

hardening-wrapper (1.29) unstable; urgency=low

  * debian/control: add Conflicts for binutils-multiarch (Closes: 579409,
    LP: #596136).
  * debian/hardening-wrapper.postrm: remove attempted diversions on
    installation failure.

 -- Kees Cook <kees@debian.org>  Fri, 09 Jul 2010 09:33:15 -0700

## hardening-wrapper 1.29

=== debian/control ===
--- 
+++ 
@@ -2,8 +2,8 @@
 Section: devel
 Priority: extra
 Build-Depends: debhelper (>= 5.0.0)
-Maintainer: Mohammad Abu-Garbeyyeh <mohammad7410@gmail.com>
-Uploaders: Kees Cook <kees@debian.org>, Moritz Muehlenhoff <jmm@debian.org>, Package Hardening <hardening-discuss@lists.alioth.debian.org>
+Maintainer: Package Hardening <hardening-discuss@lists.alioth.debian.org>
+Uploaders: Kees Cook <kees@debian.org>, Moritz Muehlenhoff <jmm@debian.org>
 Standards-Version: 3.8.4
 Homepage: http://wiki.debian.org/Hardening
 Vcs-Svn: svn://svn.debian.org/hardening/hardening-wrapper
@@ -12,6 +12,7 @@
 Package: hardening-wrapper
 Architecture: any
 Depends: gcc | g++, ${perl:Depends}, ${misc:Depends}
+Conflicts: binutils-multiarch (>= 2.20.51.20100418-1)
 Description: Compiler wrapper to enable security hardening flags
  Replaces gcc, g++, and ld with wrapper scripts that set security hardening
  compilation flags, as an alternative to changing gcc specs.  Enabled when

## hardening-wrapper 1.30

=== tests/Makefile ===
#!/usr/bin/make -f

BUILD_TREE:=../build-tree

check: $(BUILD_TREE)/cc-test
	$(MAKE) -f Makefile.wrapper $@
	$(MAKE) -f Makefile.includes $@

clean:
	rm -f $(BUILD_TREE)/cc-test
	$(MAKE) -f Makefile.wrapper $@
	$(MAKE) -f Makefile.includes $@

$(BUILD_TREE)/cc-test:
	# Check the stack protector and PIE options directly, just to have
	# a historical record in the build logs.
	$(CC) -Wall -fstack-protector hello.c -o $(BUILD_TREE)/cc-test || true
	$(BUILD_TREE)/cc-test || true
	$(CC) -Wall -fPIE -pie hello.c -o $(BUILD_TREE)/cc-test || true
	$(BUILD_TREE)/cc-test || true
	$(BUILD_TREE)/cc-test || true

=== debian/changelog ===
hardening-wrapper (1.30) unstable; urgency=low

  * debian/README.Debian: update for gcc versions, include minimal
    notes on hardening-includes (Closes: 592847, 592846).
  * debian/rules, debian/hardening-wrapper.{prerm,postinst}: add gcc-4.6
    to the diversion list.
  * debian/control: remove binutils-multiarch conflict now that ld.bfd
    is no longer diverted.

 -- Kees Cook <kees@debian.org>  Tue, 11 Jan 2011 07:54:28 -0800

=== debian/control ===
--- 
+++ 
@@ -12,7 +12,6 @@
 Package: hardening-wrapper
 Architecture: any
 Depends: gcc | g++, ${perl:Depends}, ${misc:Depends}
-Conflicts: binutils-multiarch (>= 2.20.51.20100418-1)
 Description: Compiler wrapper to enable security hardening flags
  Replaces gcc, g++, and ld with wrapper scripts that set security hardening
  compilation flags, as an alternative to changing gcc specs.  Enabled when

=== debian/rules ===
--- 
+++ 
@@ -61,7 +61,7 @@
 	install -m644 debian/lintian.overrides debian/hardening-wrapper/usr/share/lintian/overrides/hardening-wrapper
 	install build-tree/hardened-cc build-tree/hardened-c++ build-tree/hardened-ld debian/hardening-wrapper/usr/bin
 	# programatically build links (change debian/h-w.{preinst,postrm} too)
-	for ver in 4.1 4.2 4.3 4.4 4.5; do dh_link -phardening-wrapper \
+	for ver in 4.1 4.2 4.3 4.4 4.5 4.6; do dh_link -phardening-wrapper \
 		usr/bin/hardened-cc usr/bin/gcc-$$ver \
 		usr/bin/hardened-c++ usr/bin/g++-$$ver \
 		;\

## hardening-wrapper 1.33

=== debian/changelog ===
hardening-wrapper (1.33) unstable; urgency=low

  * debian/control:
    - bump to standards 3.9.2; no changes needed
    - hardening-wrapper: mark as Multi-Arch: foreign for build sanity.
  * debian/source/format: mark as 3.0 native.

 -- Kees Cook <kees@debian.org>  Sun, 03 Jul 2011 11:28:00 -0700

hardening-wrapper (1.32) unstable; urgency=low

  * debian/rules, debian/hardening-wrapper.{prerm,preinst,postinst}:
    remove gcc-4.1 diversions since it has been removed from unstable.
  * hardened-cc, hardening.make: add "-Werror=format-security" by default
    (Closes: #587358).
  * tests/Makefile.common, tests/format.c: add test for newly added
    "-Werror=format-security" default option.
  * hardened-cc, hardening.make: add "--param ssp-buffer-size=4" by
    default to catch smaller character arrays.
  * tests/Makefile.common, tests/ssp-buffer-size-{protect,skip}.c:
    add tests for newly added "--param ssp-buffer-size=4" default.
  * debian/README.Debian: updated to include newly added options.
  * hardened-cc: disable -fstack-protector when -ffreestanding used.
  * hardening.make: provide examples for working around build-time
    collisions between "-fPIE" and "-fPIC" (Closes: #596150).

 -- Kees Cook <kees@debian.org>  Fri, 18 Feb 2011 10:57:52 -0800

hardening-wrapper (1.31) unstable; urgency=low

  * tests/Makefile.common: do not require @@GLIBC suffix for nm tests.
  * tests/Makefile.wrapper: include symlink for ld.gold testing.
  * hardening-check: improve hardening-check to parse BIND_NOW also from
    the FLAGS dynamic section.

 -- Kees Cook <kees@debian.org>  Fri, 14 Jan 2011 10:19:01 -0800

=== debian/control ===
--- 
+++ 
@@ -1,16 +1,17 @@
 Source: hardening-wrapper
 Section: devel
 Priority: extra
-Build-Depends: debhelper (>= 5.0.0)
+Build-Depends: debhelper (>= 7)
 Maintainer: Package Hardening <hardening-discuss@lists.alioth.debian.org>
 Uploaders: Kees Cook <kees@debian.org>, Moritz Muehlenhoff <jmm@debian.org>
-Standards-Version: 3.8.4
+Standards-Version: 3.9.2
 Homepage: http://wiki.debian.org/Hardening
 Vcs-Svn: svn://svn.debian.org/hardening/hardening-wrapper
 Vcs-Browser: http://svn.debian.org/wsvn/hardening/hardening-wrapper/
 
 Package: hardening-wrapper
 Architecture: any
+Multi-Arch: foreign
 Depends: gcc | g++, ${perl:Depends}, ${misc:Depends}
 Description: Compiler wrapper to enable security hardening flags
  Replaces gcc, g++, and ld with wrapper scripts that set security hardening

=== debian/rules ===
--- 
+++ 
@@ -61,7 +61,7 @@
 	install -m644 debian/lintian.overrides debian/hardening-wrapper/usr/share/lintian/overrides/hardening-wrapper
 	install build-tree/hardened-cc build-tree/hardened-c++ build-tree/hardened-ld debian/hardening-wrapper/usr/bin
 	# programatically build links (change debian/h-w.{preinst,postrm} too)
-	for ver in 4.1 4.2 4.3 4.4 4.5 4.6; do dh_link -phardening-wrapper \
+	for ver in 4.2 4.3 4.4 4.5 4.6; do dh_link -phardening-wrapper \
 		usr/bin/hardened-cc usr/bin/gcc-$$ver \
 		usr/bin/hardened-c++ usr/bin/g++-$$ver \
 		;\

## hardening-wrapper 1.35

=== debian/changelog ===
hardening-wrapper (1.35) unstable; urgency=low

  * debian/control: switch to "optional" priority so lintian can depend
    on hardening-includes.
  * hardening-check: rewrite in Perl, add "--lintian" mode, to support
    fixing bug 650536.

 -- Kees Cook <kees@debian.org>  Thu, 01 Dec 2011 10:15:35 -0800

hardening-wrapper (1.34) unstable; urgency=low

  * debian/control: update VCS tags for bzr.
  * hardening{-check,.make}: correct documentation from -O2 to -O1.
  * hardened-{cc,ld}, hardening.make, debian/rules: use DEB_HOST_ARCH instead
    of of DEB_HOST_ARCH_CPU for behavioral defaults (Closes: 635642).

 -- Kees Cook <kees@debian.org>  Thu, 28 Jul 2011 12:55:17 -0700

=== debian/control ===
Source: hardening-wrapper
Section: devel
Priority: optional
Build-Depends: debhelper (>= 7), perl-base (>= 5.10)
Maintainer: Package Hardening <hardening-discuss@lists.alioth.debian.org>
Uploaders: Kees Cook <kees@debian.org>, Moritz Muehlenhoff <jmm@debian.org>
Standards-Version: 3.9.2
Homepage: http://wiki.debian.org/Hardening
Vcs-Bzr: http://anonscm.debian.org/bzr/hardening/master
Vcs-Browser: http://anonscm.debian.org/viewvc/hardening/hardening-wrapper/

Package: hardening-wrapper
Architecture: any
Multi-Arch: foreign
Depends: gcc | g++, ${perl:Depends}, ${misc:Depends}
Description: Compiler wrapper to enable security hardening flags
 Replaces gcc, g++, and ld with wrapper scripts that set security hardening
 compilation flags, as an alternative to changing gcc specs. Enabled when
 DEB_BUILD_HARDENING=1 is set.

Package: hardening-includes
Architecture: all
Depends: ${perl:Depends}, ${misc:Depends}
Description: Makefile for enabling compiler flags for security hardening
 Makefile to be included in Debian rules files. CFLAGS and LDFLAGS
 can be extended to include the respective HARDENING_* variables which
 contain architecture-validated security hardening compiler options.
 .
 Also includes the "hardening-check" script to help evaluate the hardening
 status of already compiled binaries.

## hardening-wrapper 1.36

=== debian/changelog ===
hardening-wrapper (1.36) unstable; urgency=low

  * hardening-check: fix function-finder to accept IFUNC too, improve
    reporting slightly, improve manpage to explain false alarms.

 -- Kees Cook <kees@debian.org>  Fri, 27 Jan 2012 12:07:45 -0800

## hardening-wrapper 1.36ubuntu1

=== debian/changelog ===
hardening-wrapper (1.36ubuntu1) precise; urgency=low

  * Make bash-completion Multi-Arch: foreign, so that it can satisfy
    cross-build-dependencies.

 -- Colin Watson <cjwatson@ubuntu.com>  Sat, 31 Mar 2012 02:11:12 +0100

=== debian/rules ===
--- 
+++ 
@@ -4,8 +4,8 @@
 # Uncomment this to turn on verbose mode.
 #export DH_VERBOSE=1
 
+DEB_HOST_ARCH := $(shell dpkg-architecture -qDEB_HOST_ARCH 2>/dev/null)
 DEB_HOST_ARCH_OS := $(shell dpkg-architecture -qDEB_HOST_ARCH_OS 2>/dev/null)
-DEB_HOST_ARCH_CPU := $(shell dpkg-architecture -qDEB_HOST_ARCH_CPU 2>/dev/null)
 
 include hardening.make
 DEFAULT_PIE:=$(DEB_BUILD_HARDENING_PIE)
@@ -19,8 +19,8 @@
 	mkdir -p build-tree
 	install hardened-cc hardened-ld build-tree
 
-	# Set defaults, based on OS and CPU
-	perl -pi -e 's/ #OS#/ '"$(DEB_HOST_ARCH_OS)"'/; s/ #CPU#/ '"$(DEB_HOST_ARCH_CPU)"'/;' build-tree/hardened-cc build-tree/hardened-ld
+	# Set defaults, based on OS and ARCH
+	perl -pi -e 's/ #OS#/ '"$(DEB_HOST_ARCH_OS)"'/; s/ #ARCH#/ '"$(DEB_HOST_ARCH)"'/;' build-tree/hardened-cc build-tree/hardened-ld
 	perl -pi -e "s/default{'DEB_BUILD_HARDENING_PIE'}=1;/default{'DEB_BUILD_HARDENING_PIE'}=$(DEFAULT_PIE);/;" build-tree/hardened-cc build-tree/hardened-ld
 	perl -pi -e "s/default{'DEB_BUILD_HARDENING_STACKPROTECTOR'}=1;/default{'DEB_BUILD_HARDENING_STACKPROTECTOR'}=$(DEFAULT_STACKPROT);/;" build-tree/hardened-cc build-tree/hardened-ld
 
@@ -48,7 +48,7 @@
 
 test: build-stamp test-stamp
 test-stamp:
-	(cd tests; make check)
+	make -C tests check
 	# Done testing
 	touch test-stamp
 
@@ -122,7 +122,7 @@
 	dh_link -i
 	dh_compress -i
 	dh_fixperms -i
-#	dh_perl -i
+	dh_perl -i
 	dh_installdeb -i
 	dh_gencontrol -i
 	dh_md5sums -i

## hardening-wrapper 1.36ubuntu1.1

=== debian/changelog ===
hardening-wrapper (1.36ubuntu1.1) precise-security; urgency=medium

  * hardened-cc: don't set -Wformat options if they are already set
    (LP: #1347257)

 -- Chris Coulson <chris.coulson@canonical.com>  Thu, 30 Apr 2015 18:49:28 +0100

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,8 @@
 Section: devel
 Priority: optional
 Build-Depends: debhelper (>= 7), perl-base (>= 5.10)
-Maintainer: Package Hardening <hardening-discuss@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Package Hardening <hardening-discuss@lists.alioth.debian.org>
 Uploaders: Kees Cook <kees@debian.org>, Moritz Muehlenhoff <jmm@debian.org>
 Standards-Version: 3.9.2
 Homepage: http://wiki.debian.org/Hardening
@@ -20,6 +21,7 @@
 
 Package: hardening-includes
 Architecture: all
+Multi-Arch: foreign
 Depends: ${perl:Depends}, ${misc:Depends}
 Description: Makefile for enabling compiler flags for security hardening
  Makefile to be included in Debian rules files. CFLAGS and LDFLAGS

## hardening-wrapper 2.2~bpo60+1

=== debian/changelog ===
hardening-wrapper (2.2~bpo60+1) squeeze-backports; urgency=low

  * Rebuild for squeeze-backports.

 -- Luca Falavigna <dktrkranz@debian.org>  Sun, 01 Jul 2012 13:39:46 +0200

hardening-wrapper (2.2) unstable; urgency=low

  * debian/control: add missing Dep on binutils, thanks to Stéphane Graber.
  * hardened-cc: use "=" as argument separator for better interoperability
    with dpkg-buildflags.
  * hardening-check: reset tag list for each argument (Closes: 677530).

 -- Kees Cook <kees@debian.org>  Thu, 14 Jun 2012 09:40:03 -0700

hardening-wrapper (2.1) unstable; urgency=low

  * hardening-check:
    - handle _local suffix for non-ELF i386 objects (Closes: 666895).
    - add "-h" for "--help".
    - sort and indent libc function list for easier review.
  * Makefile: retain newlines when generating libc function list.

 -- Kees Cook <kees@debian.org>  Mon, 02 Apr 2012 08:18:52 -0700

hardening-wrapper (2.0) unstable; urgency=low

  * hardening-check: add color, based on a patch from Simon Ruderich.
  * hardening-check: fix lintian tag for non-PIE ELF to "no-pie".
  * debian/rules, debian/hardening-wrapper.{prerm,postinst}: add gcc-4.7
    to the diversion list (Closes: 666520).
  * debian/control:
    - fix Vcs-Browser link for loggerhead (Closes: 664495).
    - add Multiarch tag to hardening-includes (Closes: 666471).
  * Makefile, debian/*: convert to dh(1).
  * hardening-check: generate list of libc functions at build time.
  * hardening-check, tests/Makefile.common: add support for scanning
    object archives for stack-protector and fortify (Closes: 664862).

 -- Kees Cook <kees@debian.org>  Sat, 31 Mar 2012 16:32:03 -0700

## hardening-wrapper 2.2

=== debian/control ===
--- 
+++ 
@@ -1,14 +1,13 @@
 Source: hardening-wrapper
 Section: devel
 Priority: optional
-Build-Depends: debhelper (>= 7), perl-base (>= 5.10)
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Package Hardening <hardening-discuss@lists.alioth.debian.org>
+Build-Depends: debhelper (>= 9), perl-base (>= 5.10)
+Maintainer: Package Hardening <hardening-discuss@lists.alioth.debian.org>
 Uploaders: Kees Cook <kees@debian.org>, Moritz Muehlenhoff <jmm@debian.org>
-Standards-Version: 3.9.2
+Standards-Version: 3.9.3
 Homepage: http://wiki.debian.org/Hardening
 Vcs-Bzr: http://anonscm.debian.org/bzr/hardening/master
-Vcs-Browser: http://anonscm.debian.org/viewvc/hardening/hardening-wrapper/
+Vcs-Browser: http://anonscm.debian.org/loggerhead/hardening/master/files/head:/hardening-wrapper/
 
 Package: hardening-wrapper
 Architecture: any
@@ -22,7 +21,7 @@
 Package: hardening-includes
 Architecture: all
 Multi-Arch: foreign
-Depends: ${perl:Depends}, ${misc:Depends}
+Depends: ${perl:Depends}, ${misc:Depends}, make, binutils
 Description: Makefile for enabling compiler flags for security hardening
  Makefile to be included in Debian rules files. CFLAGS and LDFLAGS
  can be extended to include the respective HARDENING_* variables which

## hardening-wrapper 2.3

=== debian/changelog ===
hardening-wrapper (2.3) unstable; urgency=low

  * debian/hardening-wrapper.{prerm,postinst,links}, debian/README.Debian:
    add gcc-4.8 to the diversion list, and sync list of compiler versions
    (Closes: 681799).
  * hardening-check: fix hash size check syntax (Closes: 682451).

 -- Kees Cook <kees@debian.org>  Sun, 16 Dec 2012 14:56:48 -0800

## hardening-wrapper 2.3ubuntu1

=== debian/changelog ===
hardening-wrapper (2.3ubuntu1) saucy; urgency=low

  * SSP is not (yet) supported on Aarch64.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 21 Jul 2013 22:25:17 +0200

## hardening-wrapper 2.5ubuntu2

=== debian/changelog ===
hardening-wrapper (2.5ubuntu2) trusty; urgency=medium

  * Allow -fstack-protector on arm64 now that GCC and glibc support it.

 -- Adam Conrad <adconrad@ubuntu.com>  Fri, 07 Mar 2014 18:51:18 +0800

hardening-wrapper (2.5ubuntu1) trusty; urgency=medium

  * Merge with Debian; remaining changes:
    - Don't install a symlink for gold on architectures not having a gold port.
    - Stop installing links for GCC 4.2, 4.3, 4.5.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 18 Dec 2013 12:36:36 +0100

hardening-wrapper (2.5) unstable; urgency=low

  * hardened-ld: detect symlink loops, like done for hardened-cc already
    (Closes: 732403).
  * hardening.make: disable stack protector on arm64 (glibc support needed).
  * debian/control: bump standards, no changes needed.

 -- Kees Cook <kees@debian.org>  Tue, 17 Dec 2013 10:01:21 -0700

hardening-wrapper (2.4ubuntu1) trusty; urgency=medium

  * Merge with Debian; remaining changes:
    - SSP is not (yet) supported on Aarch64.
  * Don't install a symlink for gold on architectures not having a gold port.
  * Stop installing links for GCC 4.2, 4.3, 4.5.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 17 Dec 2013 17:47:27 +0100

hardening-wrapper (2.4) unstable; urgency=low

  * debian/hardening-wrapper.{links,preinst,postrm}: add gcc 4.9 to
    the diversion list.
  * improve "compiler not installed" message (Closes: 709582).
  * Added short option aliasas and stopped using $PAGER for man page
    spewing, thanks to Jari Aalto (Closes: 709105). Left option ordering
    how I prefer: grouped by function and long options first.
  * hardened-{cc,ld,cc.1}: add new DEB_BUILD_HARDENING_DEBUG_OUTPUT for
    redirecting STDERR debug output, if needed (Closes: 679773).
  * debian/control: bump standards, no changes needed.

 -- Kees Cook <kees@debian.org>  Fri, 13 Sep 2013 12:46:03 -0700

=== debian/control ===
--- 
+++ 
@@ -2,9 +2,10 @@
 Section: devel
 Priority: optional
 Build-Depends: debhelper (>= 9), perl-base (>= 5.10)
-Maintainer: Package Hardening <hardening-discuss@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Package Hardening <hardening-discuss@lists.alioth.debian.org>
 Uploaders: Kees Cook <kees@debian.org>, Moritz Muehlenhoff <jmm@debian.org>
-Standards-Version: 3.9.3
+Standards-Version: 3.9.5
 Homepage: http://wiki.debian.org/Hardening
 Vcs-Bzr: http://anonscm.debian.org/bzr/hardening/master
 Vcs-Browser: http://anonscm.debian.org/loggerhead/hardening/master/files/head:/hardening-wrapper/

## hardening-wrapper 2.5ubuntu2.1

=== Makefile ===
#!/usr/bin/make -f

BUILD_TREE:=build-tree

include hardening.make
DEFAULT_PIE:=$(DEB_BUILD_HARDENING_PIE)
DEFAULT_STACKPROT:=$(DEB_BUILD_HARDENING_STACKPROTECTOR)

WRAPPERS=hardened-cc hardened-ld
TOOLS=hardening.make hardening-check
MANPAGES=hardened-cc.1 hardened-ld.1

$(BUILD_TREE)/stamp-build: $(WRAPPERS) $(TOOLS) $(MANPAGES) Makefile
	if [ -z "$(DEB_HOST_ARCH)" ]; then echo No DEB_HOST_ARCH; exit 1; fi
	if [ -z "$(DEB_HOST_ARCH_OS)" ]; then echo No DEB_HOST_ARCH_OS; exit 1; fi
	mkdir -p $(BUILD_TREE)

	# Construct wrappers.
	install $(WRAPPERS) $(BUILD_TREE)/
	# Set defaults, based on OS and ARCH.
	perl -pi -e 's/ #OS#/ '"$(DEB_HOST_ARCH_OS)"'/; s/ #ARCH#/ '"$(DEB_HOST_ARCH)"'/;' $(BUILD_TREE)/hardened-cc $(BUILD_TREE)/hardened-ld
	perl -pi -e "s/default{'DEB_BUILD_HARDENING_PIE'}=1;/default{'DEB_BUILD_HARDENING_PIE'}=$(DEFAULT_PIE);/;" $(BUILD_TREE)/hardened-cc $(BUILD_TREE)/hardened-ld
	perl -pi -e "s/default{'DEB_BUILD_HARDENING_STACKPROTECTOR'}=1;/default{'DEB_BUILD_HARDENING_STACKPROTECTOR'}=$(DEFAULT_STACKPROT);/;" $(BUILD_TREE)/hardened-cc $(BUILD_TREE)/hardened-ld
	# Duplicate cc wrapper to c++.
	install $(BUILD_TREE)/hardened-cc $(BUILD_TREE)/hardened-c++
	perl -pi -e 's/hardened-cc/hardened-c++/g; s|/usr/bin/cc|/usr/bin/c++|g;' $(BUILD_TREE)/hardened-c++

	# Construct tools.
	install $(TOOLS) $(BUILD_TREE)/
	# Do not use "shell" here because it eats newlines. We want those.
	perl -pi -e "s/^my %libc;/my %libc = (\n$$(perl hardening-check --find-libc-functions /bin/ls)\n);/;" $(BUILD_TREE)/hardening-check

	# Construct man pages.
	install $(MANPAGES) $(BUILD_TREE)/
	pod2man hardening-check > $(BUILD_TREE)/hardening-check.1
	# Duplicate cc man page to c++.
	install $(BUILD_TREE)/hardened-cc.1 $(BUILD_TREE)/hardened-c++.1
	perl -pi -e 's/hardened-cc/hardened-c++/g; s/gcc/g++/g;' $(BUILD_TREE)/hardened-c++.1

	touch $(BUILD_TREE)/stamp-build

check: $(BUILD_TREE)/stamp-build
	make -C tests check

clean:
	rm -rf $(BUILD_TREE)

old-install:
	# programatically build links (change debian/h-w.{preinst,postrm} too)
	for ver in 4.2 4.3 4.4 4.5 4.6 4.7; do dh_link -phardening-wrapper \
		usr/bin/hardened-cc usr/bin/gcc-$$ver \
		usr/bin/hardened-c++ usr/bin/g++-$$ver \
		;\
	done
	dh_link -phardening-wrapper usr/bin/hardened-ld usr/bin/ld.bfd
	dh_link -phardening-wrapper usr/bin/hardened-ld usr/bin/ld.gold

.PHONY: check clean

=== tests/Makefile ===
--- 
+++ 
@@ -19,3 +19,5 @@
 	$(CC) -Wall -fPIE -pie hello.c -o $(BUILD_TREE)/cc-test || true
 	$(BUILD_TREE)/cc-test || true
 	$(BUILD_TREE)/cc-test || true
+
+.PHONY: check clean

=== debian/changelog ===
hardening-wrapper (2.5ubuntu2.1) trusty-proposed; urgency=medium

  [ Backport from 14.10 ]
  * hardened-cc: don't set -Wformat options if they are already set
    (LP: #1347257)

 -- Matthias Klose <doko@ubuntu.com>  Tue, 07 Oct 2014 17:10:55 +0200

## hardening-wrapper 2.5+nmu1ubuntu2

=== debian/changelog ===
hardening-wrapper (2.5+nmu1ubuntu2) utopic; urgency=medium

  * Divert ld.gold on arm64.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 14 Oct 2014 12:29:01 +0200

hardening-wrapper (2.5+nmu1ubuntu1) utopic; urgency=low

  * Merge with Debian.  Remaining changes:
    - hardened-cc: don't set -Wformat options if they are already set
    - Allow -fstack-protector on arm64
    - Don't install a symlink for gold on architectures not having a gold port.
    - Stop installing links for GCC 4.2, 4.3, 4.5.

 -- Steve Beattie <sbeattie@ubuntu.com>  Wed, 17 Sep 2014 23:09:19 -0700

hardening-wrapper (2.5+nmu1) unstable; urgency=medium

  * Non-maintainer upload.
  * Disable standard hardening flags for test suite, to avoid conflicting
    with hardening-wrapper's own flags which are being tested. Thanks to
    Romain Francoise for the patch (Closes: 752717).

 -- Aurelien Jarno <aurel32@debian.org>  Thu, 21 Aug 2014 13:50:24 +0200

hardening-wrapper (2.5ubuntu3) utopic; urgency=medium

  * hardened-cc: don't set -Wformat options if they are already set
    (LP: #1347257)

 -- Steve Beattie <sbeattie@ubuntu.com>  Thu, 24 Jul 2014 15:55:40 -0700

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS=hardening=-all

%:
	dh $@
